# coding: utf-8

"""
    Conversations Inbox & Messages

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from hubspot.conversations.conversations.models.error_detail import ErrorDetail
from typing import Optional, Set
from typing_extensions import Self

class Error(BaseModel):
    """
    Error
    """ # noqa: E501
    sub_category: Optional[StrictStr] = Field(default=None, description="A specific category that contains more specific detail about the error", alias="subCategory")
    context: Optional[Dict[str, List[StrictStr]]] = Field(default=None, description="Context about the error condition")
    correlation_id: StrictStr = Field(description="A unique identifier for the request. Include this value with any error reports or support tickets", alias="correlationId")
    links: Optional[Dict[str, StrictStr]] = Field(default=None, description="A map of link names to associated URIs containing documentation about the error or recommended remediation steps")
    message: StrictStr = Field(description="A human readable message describing the error along with remediation steps where appropriate")
    category: StrictStr = Field(description="The error category")
    errors: Optional[List[ErrorDetail]] = Field(default=None, description="further information about the error")
    __properties: ClassVar[List[str]] = ["subCategory", "context", "correlationId", "links", "message", "category", "errors"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Error from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in errors (list)
        _items = []
        if self.errors:
            for _item_errors in self.errors:
                if _item_errors:
                    _items.append(_item_errors.to_dict())
            _dict['errors'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Error from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "subCategory": obj.get("subCategory"),
            "context": obj.get("context"),
            "correlationId": obj.get("correlationId"),
            "links": obj.get("links"),
            "message": obj.get("message"),
            "category": obj.get("category"),
            "errors": [ErrorDetail.from_dict(_item) for _item in obj["errors"]] if obj.get("errors") is not None else None
        })
        return _obj


