# coding: utf-8

"""
    Conversations Inbox & Messages

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from hubspot.conversations.conversations.models.agent_actor import AgentActor
from hubspot.conversations.conversations.models.bot_actor import BotActor
from hubspot.conversations.conversations.models.email_actor import EmailActor
from hubspot.conversations.conversations.models.integrator_actor import IntegratorActor
from hubspot.conversations.conversations.models.system_actor import SystemActor
from hubspot.conversations.conversations.models.visitor_actor import VisitorActor
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

PUBLICACTOR_ONE_OF_SCHEMAS = ["AgentActor", "BotActor", "EmailActor", "IntegratorActor", "SystemActor", "VisitorActor"]

class PublicActor(BaseModel):
    """
    PublicActor
    """
    # data type: AgentActor
    oneof_schema_1_validator: Optional[AgentActor] = None
    # data type: BotActor
    oneof_schema_2_validator: Optional[BotActor] = None
    # data type: IntegratorActor
    oneof_schema_3_validator: Optional[IntegratorActor] = None
    # data type: SystemActor
    oneof_schema_4_validator: Optional[SystemActor] = None
    # data type: VisitorActor
    oneof_schema_5_validator: Optional[VisitorActor] = None
    # data type: EmailActor
    oneof_schema_6_validator: Optional[EmailActor] = None
    actual_instance: Optional[Union[AgentActor, BotActor, EmailActor, IntegratorActor, SystemActor, VisitorActor]] = None
    one_of_schemas: Set[str] = { "AgentActor", "BotActor", "EmailActor", "IntegratorActor", "SystemActor", "VisitorActor" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = PublicActor.model_construct()
        error_messages = []
        match = 0
        # validate data type: AgentActor
        if not isinstance(v, AgentActor):
            error_messages.append(f"Error! Input type `{type(v)}` is not `AgentActor`")
        else:
            match += 1
        # validate data type: BotActor
        if not isinstance(v, BotActor):
            error_messages.append(f"Error! Input type `{type(v)}` is not `BotActor`")
        else:
            match += 1
        # validate data type: IntegratorActor
        if not isinstance(v, IntegratorActor):
            error_messages.append(f"Error! Input type `{type(v)}` is not `IntegratorActor`")
        else:
            match += 1
        # validate data type: SystemActor
        if not isinstance(v, SystemActor):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SystemActor`")
        else:
            match += 1
        # validate data type: VisitorActor
        if not isinstance(v, VisitorActor):
            error_messages.append(f"Error! Input type `{type(v)}` is not `VisitorActor`")
        else:
            match += 1
        # validate data type: EmailActor
        if not isinstance(v, EmailActor):
            error_messages.append(f"Error! Input type `{type(v)}` is not `EmailActor`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in PublicActor with oneOf schemas: AgentActor, BotActor, EmailActor, IntegratorActor, SystemActor, VisitorActor. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in PublicActor with oneOf schemas: AgentActor, BotActor, EmailActor, IntegratorActor, SystemActor, VisitorActor. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into AgentActor
        try:
            instance.actual_instance = AgentActor.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into BotActor
        try:
            instance.actual_instance = BotActor.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into IntegratorActor
        try:
            instance.actual_instance = IntegratorActor.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SystemActor
        try:
            instance.actual_instance = SystemActor.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into VisitorActor
        try:
            instance.actual_instance = VisitorActor.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into EmailActor
        try:
            instance.actual_instance = EmailActor.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into PublicActor with oneOf schemas: AgentActor, BotActor, EmailActor, IntegratorActor, SystemActor, VisitorActor. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into PublicActor with oneOf schemas: AgentActor, BotActor, EmailActor, IntegratorActor, SystemActor, VisitorActor. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], AgentActor, BotActor, EmailActor, IntegratorActor, SystemActor, VisitorActor]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


