# coding: utf-8

"""
    Conversations Inbox & Messages

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from hubspot.conversations.conversations.models.public_delivery_identifier import PublicDeliveryIdentifier
from typing import Optional, Set
from typing_extensions import Self

class PublicChannelAccount(BaseModel):
    """
    PublicChannelAccount
    """ # noqa: E501
    created_at: Optional[datetime] = Field(default=None, alias="createdAt")
    archived_at: Optional[datetime] = Field(default=None, alias="archivedAt")
    archived: StrictBool
    authorized: Optional[StrictBool] = None
    name: Optional[StrictStr] = Field(default=None, description="The name of the channel account.")
    active: Optional[StrictBool] = Field(default=None, description="Whether the channel account is turned on.")
    delivery_identifier: Optional[PublicDeliveryIdentifier] = Field(default=None, alias="deliveryIdentifier")
    id: Optional[StrictStr] = Field(default=None, description="The ID of the channel account.")
    inbox_id: Optional[StrictStr] = Field(default=None, description="The ID of the conversations inbox that contains the channel account.", alias="inboxId")
    channel_id: Optional[StrictStr] = Field(default=None, description="The ID of the channel that the channel account is an instance of.", alias="channelId")
    __properties: ClassVar[List[str]] = ["createdAt", "archivedAt", "archived", "authorized", "name", "active", "deliveryIdentifier", "id", "inboxId", "channelId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of PublicChannelAccount from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of delivery_identifier
        if self.delivery_identifier:
            _dict['deliveryIdentifier'] = self.delivery_identifier.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of PublicChannelAccount from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "createdAt": obj.get("createdAt"),
            "archivedAt": obj.get("archivedAt"),
            "archived": obj.get("archived"),
            "authorized": obj.get("authorized"),
            "name": obj.get("name"),
            "active": obj.get("active"),
            "deliveryIdentifier": PublicDeliveryIdentifier.from_dict(obj["deliveryIdentifier"]) if obj.get("deliveryIdentifier") is not None else None,
            "id": obj.get("id"),
            "inboxId": obj.get("inboxId"),
            "channelId": obj.get("channelId")
        })
        return _obj


