# coding: utf-8

"""
    Conversations Custom Channels

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v3
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from hubspot.conversations.custom_channels.models.public_contact import PublicContact
from hubspot.conversations.custom_channels.models.public_file import PublicFile
from hubspot.conversations.custom_channels.models.public_location import PublicLocation
from hubspot.conversations.custom_channels.models.public_message_header import PublicMessageHeader
from hubspot.conversations.custom_channels.models.public_quick_replies import PublicQuickReplies
from hubspot.conversations.custom_channels.models.public_unsupported_content import PublicUnsupportedContent
from hubspot.conversations.custom_channels.models.public_whats_app_template_metadata import PublicWhatsAppTemplateMetadata
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

PUBLICCONVERSATIONSMESSAGEATTACHMENTSINNER_ONE_OF_SCHEMAS = ["PublicContact", "PublicFile", "PublicLocation", "PublicMessageHeader", "PublicQuickReplies", "PublicUnsupportedContent", "PublicWhatsAppTemplateMetadata"]

class PublicConversationsMessageAttachmentsInner(BaseModel):
    """
    PublicConversationsMessageAttachmentsInner
    """
    # data type: PublicFile
    oneof_schema_1_validator: Optional[PublicFile] = None
    # data type: PublicLocation
    oneof_schema_2_validator: Optional[PublicLocation] = None
    # data type: PublicContact
    oneof_schema_3_validator: Optional[PublicContact] = None
    # data type: PublicUnsupportedContent
    oneof_schema_4_validator: Optional[PublicUnsupportedContent] = None
    # data type: PublicMessageHeader
    oneof_schema_5_validator: Optional[PublicMessageHeader] = None
    # data type: PublicQuickReplies
    oneof_schema_6_validator: Optional[PublicQuickReplies] = None
    # data type: PublicWhatsAppTemplateMetadata
    oneof_schema_7_validator: Optional[PublicWhatsAppTemplateMetadata] = None
    actual_instance: Optional[Union[PublicContact, PublicFile, PublicLocation, PublicMessageHeader, PublicQuickReplies, PublicUnsupportedContent, PublicWhatsAppTemplateMetadata]] = None
    one_of_schemas: Set[str] = { "PublicContact", "PublicFile", "PublicLocation", "PublicMessageHeader", "PublicQuickReplies", "PublicUnsupportedContent", "PublicWhatsAppTemplateMetadata" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = PublicConversationsMessageAttachmentsInner.model_construct()
        error_messages = []
        match = 0
        # validate data type: PublicFile
        if not isinstance(v, PublicFile):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PublicFile`")
        else:
            match += 1
        # validate data type: PublicLocation
        if not isinstance(v, PublicLocation):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PublicLocation`")
        else:
            match += 1
        # validate data type: PublicContact
        if not isinstance(v, PublicContact):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PublicContact`")
        else:
            match += 1
        # validate data type: PublicUnsupportedContent
        if not isinstance(v, PublicUnsupportedContent):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PublicUnsupportedContent`")
        else:
            match += 1
        # validate data type: PublicMessageHeader
        if not isinstance(v, PublicMessageHeader):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PublicMessageHeader`")
        else:
            match += 1
        # validate data type: PublicQuickReplies
        if not isinstance(v, PublicQuickReplies):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PublicQuickReplies`")
        else:
            match += 1
        # validate data type: PublicWhatsAppTemplateMetadata
        if not isinstance(v, PublicWhatsAppTemplateMetadata):
            error_messages.append(f"Error! Input type `{type(v)}` is not `PublicWhatsAppTemplateMetadata`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in PublicConversationsMessageAttachmentsInner with oneOf schemas: PublicContact, PublicFile, PublicLocation, PublicMessageHeader, PublicQuickReplies, PublicUnsupportedContent, PublicWhatsAppTemplateMetadata. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in PublicConversationsMessageAttachmentsInner with oneOf schemas: PublicContact, PublicFile, PublicLocation, PublicMessageHeader, PublicQuickReplies, PublicUnsupportedContent, PublicWhatsAppTemplateMetadata. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into PublicFile
        try:
            instance.actual_instance = PublicFile.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PublicLocation
        try:
            instance.actual_instance = PublicLocation.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PublicContact
        try:
            instance.actual_instance = PublicContact.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PublicUnsupportedContent
        try:
            instance.actual_instance = PublicUnsupportedContent.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PublicMessageHeader
        try:
            instance.actual_instance = PublicMessageHeader.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PublicQuickReplies
        try:
            instance.actual_instance = PublicQuickReplies.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into PublicWhatsAppTemplateMetadata
        try:
            instance.actual_instance = PublicWhatsAppTemplateMetadata.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into PublicConversationsMessageAttachmentsInner with oneOf schemas: PublicContact, PublicFile, PublicLocation, PublicMessageHeader, PublicQuickReplies, PublicUnsupportedContent, PublicWhatsAppTemplateMetadata. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into PublicConversationsMessageAttachmentsInner with oneOf schemas: PublicContact, PublicFile, PublicLocation, PublicMessageHeader, PublicQuickReplies, PublicUnsupportedContent, PublicWhatsAppTemplateMetadata. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], PublicContact, PublicFile, PublicLocation, PublicMessageHeader, PublicQuickReplies, PublicUnsupportedContent, PublicWhatsAppTemplateMetadata]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


