# coding: utf-8

"""
    Marketing Events

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)  # noqa: E501

    The version of the OpenAPI document: v3
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from hubspot.marketing.events.api_client import ApiClient
from hubspot.marketing.events.exceptions import ApiTypeError, ApiValueError  # noqa: F401


class ListAssociationsApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def associate_by_external_account_and_event_ids(self, external_account_id, external_event_id, list_id, **kwargs):  # noqa: E501
        """Associate a list with a marketing event  # noqa: E501

        Associates a list with a marketing event by external account id, external event id, and ILS list id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.associate_by_external_account_and_event_ids(external_account_id, external_event_id, list_id, async_req=True)
        >>> result = thread.get()

        :param external_account_id: The accountId that is associated with this marketing event in the external event application. (required)
        :type external_account_id: str
        :param external_event_id: The id of the marketing event in the external event application. (required)
        :type external_event_id: str
        :param list_id: The ILS ID of the list. (required)
        :type list_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs["_return_http_data_only"] = True
        return self.associate_by_external_account_and_event_ids_with_http_info(external_account_id, external_event_id, list_id, **kwargs)  # noqa: E501

    def associate_by_external_account_and_event_ids_with_http_info(self, external_account_id, external_event_id, list_id, **kwargs):  # noqa: E501
        """Associate a list with a marketing event  # noqa: E501

        Associates a list with a marketing event by external account id, external event id, and ILS list id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.associate_by_external_account_and_event_ids_with_http_info(external_account_id, external_event_id, list_id, async_req=True)
        >>> result = thread.get()

        :param external_account_id: The accountId that is associated with this marketing event in the external event application. (required)
        :type external_account_id: str
        :param external_event_id: The id of the marketing event in the external event application. (required)
        :type external_event_id: str
        :param list_id: The ILS ID of the list. (required)
        :type list_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        local_var_params = locals()

        all_params = ["external_account_id", "external_event_id", "list_id"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout", "_request_auth", "_content_type", "_headers"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method associate_by_external_account_and_event_ids" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]
        # verify the required parameter 'external_account_id' is set
        if self.api_client.client_side_validation and local_var_params.get("external_account_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `external_account_id` when calling `associate_by_external_account_and_event_ids`")  # noqa: E501
        # verify the required parameter 'external_event_id' is set
        if self.api_client.client_side_validation and local_var_params.get("external_event_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `external_event_id` when calling `associate_by_external_account_and_event_ids`")  # noqa: E501
        # verify the required parameter 'list_id' is set
        if self.api_client.client_side_validation and local_var_params.get("list_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `list_id` when calling `associate_by_external_account_and_event_ids`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "external_account_id" in local_var_params:
            path_params["externalAccountId"] = local_var_params["external_account_id"]  # noqa: E501
        if "external_event_id" in local_var_params:
            path_params["externalEventId"] = local_var_params["external_event_id"]  # noqa: E501
        if "list_id" in local_var_params:
            path_params["listId"] = local_var_params["list_id"]  # noqa: E501

        query_params = []

        header_params = dict(local_var_params.get("_headers", {}))

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["*/*"])  # noqa: E501

        # Authentication setting
        auth_settings = ["oauth2"]  # noqa: E501

        response_types_map = {}

        return self.api_client.call_api(
            "/marketing/v3/marketing-events/associations/{externalAccountId}/{externalEventId}/lists/{listId}",
            "PUT",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_types_map=response_types_map,
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get("_request_auth"),
        )

    def associate_by_marketing_event_id(self, marketing_event_id, list_id, **kwargs):  # noqa: E501
        """Associate a list with a marketing event  # noqa: E501

        Associates a list with a marketing event by marketing event id and ILS list id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.associate_by_marketing_event_id(marketing_event_id, list_id, async_req=True)
        >>> result = thread.get()

        :param marketing_event_id: The internal id of the marketing event in HubSpot. (required)
        :type marketing_event_id: str
        :param list_id: The ILS ID of the list. (required)
        :type list_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs["_return_http_data_only"] = True
        return self.associate_by_marketing_event_id_with_http_info(marketing_event_id, list_id, **kwargs)  # noqa: E501

    def associate_by_marketing_event_id_with_http_info(self, marketing_event_id, list_id, **kwargs):  # noqa: E501
        """Associate a list with a marketing event  # noqa: E501

        Associates a list with a marketing event by marketing event id and ILS list id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.associate_by_marketing_event_id_with_http_info(marketing_event_id, list_id, async_req=True)
        >>> result = thread.get()

        :param marketing_event_id: The internal id of the marketing event in HubSpot. (required)
        :type marketing_event_id: str
        :param list_id: The ILS ID of the list. (required)
        :type list_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        local_var_params = locals()

        all_params = ["marketing_event_id", "list_id"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout", "_request_auth", "_content_type", "_headers"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method associate_by_marketing_event_id" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]
        # verify the required parameter 'marketing_event_id' is set
        if self.api_client.client_side_validation and local_var_params.get("marketing_event_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `marketing_event_id` when calling `associate_by_marketing_event_id`")  # noqa: E501
        # verify the required parameter 'list_id' is set
        if self.api_client.client_side_validation and local_var_params.get("list_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `list_id` when calling `associate_by_marketing_event_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "marketing_event_id" in local_var_params:
            path_params["marketingEventId"] = local_var_params["marketing_event_id"]  # noqa: E501
        if "list_id" in local_var_params:
            path_params["listId"] = local_var_params["list_id"]  # noqa: E501

        query_params = []

        header_params = dict(local_var_params.get("_headers", {}))

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["*/*"])  # noqa: E501

        # Authentication setting
        auth_settings = ["oauth2"]  # noqa: E501

        response_types_map = {}

        return self.api_client.call_api(
            "/marketing/v3/marketing-events/associations/{marketingEventId}/lists/{listId}",
            "PUT",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_types_map=response_types_map,
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get("_request_auth"),
        )

    def disassociate_by_external_account_and_event_ids(self, external_account_id, external_event_id, list_id, **kwargs):  # noqa: E501
        """Disassociate a list from a marketing event  # noqa: E501

        Disassociates a list from a marketing event by external account id, external event id, and ILS list id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.disassociate_by_external_account_and_event_ids(external_account_id, external_event_id, list_id, async_req=True)
        >>> result = thread.get()

        :param external_account_id: The accountId that is associated with this marketing event in the external event application. (required)
        :type external_account_id: str
        :param external_event_id: The id of the marketing event in the external event application. (required)
        :type external_event_id: str
        :param list_id: The ILS ID of the list. (required)
        :type list_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs["_return_http_data_only"] = True
        return self.disassociate_by_external_account_and_event_ids_with_http_info(external_account_id, external_event_id, list_id, **kwargs)  # noqa: E501

    def disassociate_by_external_account_and_event_ids_with_http_info(self, external_account_id, external_event_id, list_id, **kwargs):  # noqa: E501
        """Disassociate a list from a marketing event  # noqa: E501

        Disassociates a list from a marketing event by external account id, external event id, and ILS list id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.disassociate_by_external_account_and_event_ids_with_http_info(external_account_id, external_event_id, list_id, async_req=True)
        >>> result = thread.get()

        :param external_account_id: The accountId that is associated with this marketing event in the external event application. (required)
        :type external_account_id: str
        :param external_event_id: The id of the marketing event in the external event application. (required)
        :type external_event_id: str
        :param list_id: The ILS ID of the list. (required)
        :type list_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        local_var_params = locals()

        all_params = ["external_account_id", "external_event_id", "list_id"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout", "_request_auth", "_content_type", "_headers"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method disassociate_by_external_account_and_event_ids" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]
        # verify the required parameter 'external_account_id' is set
        if self.api_client.client_side_validation and local_var_params.get("external_account_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `external_account_id` when calling `disassociate_by_external_account_and_event_ids`")  # noqa: E501
        # verify the required parameter 'external_event_id' is set
        if self.api_client.client_side_validation and local_var_params.get("external_event_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `external_event_id` when calling `disassociate_by_external_account_and_event_ids`")  # noqa: E501
        # verify the required parameter 'list_id' is set
        if self.api_client.client_side_validation and local_var_params.get("list_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `list_id` when calling `disassociate_by_external_account_and_event_ids`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "external_account_id" in local_var_params:
            path_params["externalAccountId"] = local_var_params["external_account_id"]  # noqa: E501
        if "external_event_id" in local_var_params:
            path_params["externalEventId"] = local_var_params["external_event_id"]  # noqa: E501
        if "list_id" in local_var_params:
            path_params["listId"] = local_var_params["list_id"]  # noqa: E501

        query_params = []

        header_params = dict(local_var_params.get("_headers", {}))

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["*/*"])  # noqa: E501

        # Authentication setting
        auth_settings = ["oauth2"]  # noqa: E501

        response_types_map = {}

        return self.api_client.call_api(
            "/marketing/v3/marketing-events/associations/{externalAccountId}/{externalEventId}/lists/{listId}",
            "DELETE",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_types_map=response_types_map,
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get("_request_auth"),
        )

    def disassociate_by_marketing_event_id(self, marketing_event_id, list_id, **kwargs):  # noqa: E501
        """Disassociate a list from a marketing event  # noqa: E501

        Disassociates a list from a marketing event by marketing event id and ILS list id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.disassociate_by_marketing_event_id(marketing_event_id, list_id, async_req=True)
        >>> result = thread.get()

        :param marketing_event_id: The internal id of the marketing event in HubSpot. (required)
        :type marketing_event_id: str
        :param list_id: The ILS ID of the list. (required)
        :type list_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """
        kwargs["_return_http_data_only"] = True
        return self.disassociate_by_marketing_event_id_with_http_info(marketing_event_id, list_id, **kwargs)  # noqa: E501

    def disassociate_by_marketing_event_id_with_http_info(self, marketing_event_id, list_id, **kwargs):  # noqa: E501
        """Disassociate a list from a marketing event  # noqa: E501

        Disassociates a list from a marketing event by marketing event id and ILS list id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.disassociate_by_marketing_event_id_with_http_info(marketing_event_id, list_id, async_req=True)
        >>> result = thread.get()

        :param marketing_event_id: The internal id of the marketing event in HubSpot. (required)
        :type marketing_event_id: str
        :param list_id: The ILS ID of the list. (required)
        :type list_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: None
        """

        local_var_params = locals()

        all_params = ["marketing_event_id", "list_id"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout", "_request_auth", "_content_type", "_headers"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method disassociate_by_marketing_event_id" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]
        # verify the required parameter 'marketing_event_id' is set
        if self.api_client.client_side_validation and local_var_params.get("marketing_event_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `marketing_event_id` when calling `disassociate_by_marketing_event_id`")  # noqa: E501
        # verify the required parameter 'list_id' is set
        if self.api_client.client_side_validation and local_var_params.get("list_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `list_id` when calling `disassociate_by_marketing_event_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "marketing_event_id" in local_var_params:
            path_params["marketingEventId"] = local_var_params["marketing_event_id"]  # noqa: E501
        if "list_id" in local_var_params:
            path_params["listId"] = local_var_params["list_id"]  # noqa: E501

        query_params = []

        header_params = dict(local_var_params.get("_headers", {}))

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["*/*"])  # noqa: E501

        # Authentication setting
        auth_settings = ["oauth2"]  # noqa: E501

        response_types_map = {}

        return self.api_client.call_api(
            "/marketing/v3/marketing-events/associations/{marketingEventId}/lists/{listId}",
            "DELETE",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_types_map=response_types_map,
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get("_request_auth"),
        )

    def get_all_by_external_account_and_event_ids(self, external_account_id, external_event_id, **kwargs):  # noqa: E501
        """Get lists associated with a marketing event  # noqa: E501

        Gets lists associated with a marketing event by external account id and external event id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_all_by_external_account_and_event_ids(external_account_id, external_event_id, async_req=True)
        >>> result = thread.get()

        :param external_account_id: The accountId that is associated with this marketing event in the external event application (required)
        :type external_account_id: str
        :param external_event_id: The id of the marketing event in the external event application. (required)
        :type external_event_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CollectionResponseWithTotalPublicListNoPaging
        """
        kwargs["_return_http_data_only"] = True
        return self.get_all_by_external_account_and_event_ids_with_http_info(external_account_id, external_event_id, **kwargs)  # noqa: E501

    def get_all_by_external_account_and_event_ids_with_http_info(self, external_account_id, external_event_id, **kwargs):  # noqa: E501
        """Get lists associated with a marketing event  # noqa: E501

        Gets lists associated with a marketing event by external account id and external event id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_all_by_external_account_and_event_ids_with_http_info(external_account_id, external_event_id, async_req=True)
        >>> result = thread.get()

        :param external_account_id: The accountId that is associated with this marketing event in the external event application (required)
        :type external_account_id: str
        :param external_event_id: The id of the marketing event in the external event application. (required)
        :type external_event_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CollectionResponseWithTotalPublicListNoPaging, status_code(int), headers(HTTPHeaderDict))
        """

        local_var_params = locals()

        all_params = ["external_account_id", "external_event_id"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout", "_request_auth", "_content_type", "_headers"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method get_all_by_external_account_and_event_ids" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]
        # verify the required parameter 'external_account_id' is set
        if self.api_client.client_side_validation and local_var_params.get("external_account_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `external_account_id` when calling `get_all_by_external_account_and_event_ids`")  # noqa: E501
        # verify the required parameter 'external_event_id' is set
        if self.api_client.client_side_validation and local_var_params.get("external_event_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `external_event_id` when calling `get_all_by_external_account_and_event_ids`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "external_account_id" in local_var_params:
            path_params["externalAccountId"] = local_var_params["external_account_id"]  # noqa: E501
        if "external_event_id" in local_var_params:
            path_params["externalEventId"] = local_var_params["external_event_id"]  # noqa: E501

        query_params = []

        header_params = dict(local_var_params.get("_headers", {}))

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["application/json", "*/*"])  # noqa: E501

        # Authentication setting
        auth_settings = ["oauth2"]  # noqa: E501

        response_types_map = {
            200: "CollectionResponseWithTotalPublicListNoPaging",
        }

        return self.api_client.call_api(
            "/marketing/v3/marketing-events/associations/{externalAccountId}/{externalEventId}/lists",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_types_map=response_types_map,
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get("_request_auth"),
        )

    def get_all_by_marketing_event_id(self, marketing_event_id, **kwargs):  # noqa: E501
        """Get lists associated with a marketing event  # noqa: E501

        Gets lists associated with a marketing event by marketing event id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_all_by_marketing_event_id(marketing_event_id, async_req=True)
        >>> result = thread.get()

        :param marketing_event_id: The internal id of the marketing event in HubSpot. (required)
        :type marketing_event_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: CollectionResponseWithTotalPublicListNoPaging
        """
        kwargs["_return_http_data_only"] = True
        return self.get_all_by_marketing_event_id_with_http_info(marketing_event_id, **kwargs)  # noqa: E501

    def get_all_by_marketing_event_id_with_http_info(self, marketing_event_id, **kwargs):  # noqa: E501
        """Get lists associated with a marketing event  # noqa: E501

        Gets lists associated with a marketing event by marketing event id  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_all_by_marketing_event_id_with_http_info(marketing_event_id, async_req=True)
        >>> result = thread.get()

        :param marketing_event_id: The internal id of the marketing event in HubSpot. (required)
        :type marketing_event_id: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _return_http_data_only: response data without head status code
                                       and headers
        :type _return_http_data_only: bool, optional
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :type _preload_content: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(CollectionResponseWithTotalPublicListNoPaging, status_code(int), headers(HTTPHeaderDict))
        """

        local_var_params = locals()

        all_params = ["marketing_event_id"]
        all_params.extend(["async_req", "_return_http_data_only", "_preload_content", "_request_timeout", "_request_auth", "_content_type", "_headers"])

        for key, val in six.iteritems(local_var_params["kwargs"]):
            if key not in all_params:
                raise ApiTypeError("Got an unexpected keyword argument '%s'" " to method get_all_by_marketing_event_id" % key)
            local_var_params[key] = val
        del local_var_params["kwargs"]
        # verify the required parameter 'marketing_event_id' is set
        if self.api_client.client_side_validation and local_var_params.get("marketing_event_id") is None:  # noqa: E501
            raise ApiValueError("Missing the required parameter `marketing_event_id` when calling `get_all_by_marketing_event_id`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if "marketing_event_id" in local_var_params:
            path_params["marketingEventId"] = local_var_params["marketing_event_id"]  # noqa: E501

        query_params = []

        header_params = dict(local_var_params.get("_headers", {}))

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params["Accept"] = self.api_client.select_header_accept(["application/json", "*/*"])  # noqa: E501

        # Authentication setting
        auth_settings = ["oauth2"]  # noqa: E501

        response_types_map = {
            200: "CollectionResponseWithTotalPublicListNoPaging",
        }

        return self.api_client.call_api(
            "/marketing/v3/marketing-events/associations/{marketingEventId}/lists",
            "GET",
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_types_map=response_types_map,
            auth_settings=auth_settings,
            async_req=local_var_params.get("async_req"),
            _return_http_data_only=local_var_params.get("_return_http_data_only"),  # noqa: E501
            _preload_content=local_var_params.get("_preload_content", True),
            _request_timeout=local_var_params.get("_request_timeout"),
            collection_formats=collection_formats,
            _request_auth=local_var_params.get("_request_auth"),
        )
